#!/usr/bin/perl
####################
#htsearch.cgi Version 0.3: a perl wrapper for htdig
#By Clint Gilders (thermin@pipcom.com)
#Released under the GNU/GPL
####################
use CGI qw/:standard/;
use LWP::Simple;

print header;
##############
#Construct the query to send to the real htsearch
$query = q'?';
@params = qw'config exclude keywords matchesperpage method page restrict sort words';
foreach $i(@params) {
	if(defined(param($i))) {
		$query_list{"$i"} = param($i);	
	}
}
$count = 0;
foreach $field(@params) {
	if(defined($query_list{$field})) {
		if($count > 0) {
			$query .= "\&";
		}
		$query .= "$field=$query_list{$field}";
		$count++;
	}
}

#######################
#The various URLs we will get with LWP
$HEADER_URL = 'http://www.yourdomain.com/header_file.html';
$BANNER_URL = 'http://www.yourdomain.com/banner.php3';
$URL = qq(http://www.yourdomain.com/cgi-bin/htsearch$query);
$FOOTER_URL = 'http://www.yourdomain.com/footer_file.html';


########################
#Get the URLs with LWP
print GetUrl($HEADER_URL);
print qq(<CENTER>);
print GetUrl($BANNER_URL);
print qq(</CENTER>\n);
print qq(<BR>);
print Form();
print GetUrl($URL);
print GetUrl($FOOTER_URL);


##################
#subroutines
sub GetUrl {
	$url = shift;
	unless (defined ($content = get $url)) {
		die "Could not get $url\n";
	}
	if($content =~ m|NOMATCH|) {
		$content = qq(<CENTER><B>No Matches were found.  Please try your search again</B><BR></CENTER>\n);
	}
	return $content ."\n";	
}

sub Form {
	return q(
	<CENTER>
	<FORM METHOD="GET" ACTION="http://www.yourdomain.com/cgi-bin/htsearch.cgi">
	<INPUT TYPE="HIDDEN" name="method" value="and">
	<INPUT TYPE="hidden" name="config" value="htdigwrap">
	<INPUT TYPE="hidden" name="page" value="1">
	Search:
	<INPUT TYPE="text" size="30" name="words">
	<INPUT TYPE="submit" value="Search">
	</FORM>
	</CENTER>
	);
}
